// Dodati fajlove koje ste napravili
#include <fstream>
#include <iostream>
#include <string>
using namespace std;

/*
	Izlaz:
		[Pera] Zdravo!
		Zika - Cao svima!

	Poeni: 
		2
*/
void test_0() {
	fstream file("test_0.txt", ios::out);

	Message m1("Pera", "Zdravo!");
	Message m2("Zika", "Cao svima!");

	file << m1 << endl;
	file << m2.getUsername() << " - " << m2.getMessage() << endl;
	file.close();
}

/*
	Izlaz:
		Pera [0]
		Zika [0]
		Pera [1]
		Zika [0]

	Poeni:
		2
*/
void test_1() {
	fstream file("test_1.txt", ios::out);

	User u1("Pera");
	User u2("Zika");

	file << u1 << endl;
	file << u2 << endl;

	Chat chat;

	u1.enterChat(&chat);

	file << u1 << endl;
	file << u2 << endl;
	file.close();
}

/*
	Ulaz:
		Cao!

	Izlaz:
		Pera [1]
		Zika [1]
		id = 2
		Pera (0)
		Zika (0)

		id = 2
		Pera (1)
		Zika (0)
		[Pera] Cao!

	Poeni:
		2
*/
void test_2() {
	fstream file("test_2.txt", ios::out);

	User u1("Pera");
	User u2("Zika");

	Chat chat;

	chat.addUser(&u1);
	chat.addUser(&u2);

	file << u1 << endl;
	file << u2 << endl;

	file << chat << endl;

	u1.sendMessage(chat.getId());

	file << chat << endl;
	file.close();
}

/*	
	Ulaz:
		Koliko imate poena?
		Ja 29, ti?
		Ja 17 :/
		Ajoj
		A dobro, nije lose

	Izlaz:
		id = 3
		Pera (3)
		Zika (2)
		Mika (1)
		[Zika] Koliko imate poena?
		[Pera] Ja 29, ti?
		[Zika] Ja 17 :/
		[Pera] Ajoj
		[Pera] A dobro, nije lose

	Poeni:
		2
*/
void test_3(){
	fstream file("test_3.txt", ios::out);

	User u1("Pera");
	User u2("Zika");
	User u3("Mika");

	Chat chat;

	chat.addUser(&u1);
	chat.addUser(&u2);
	chat.addUser(&u3);

	u3.sendMessage(chat.getId());
	u2.sendMessage(chat.getId());
	u1.sendMessage(chat.getId());
	u2.sendMessage(chat.getId());
	u1.sendMessage(chat.getId());
	u1.sendMessage(chat.getId());

	file << chat;
	file.close();
}

/*
	Izlaz:
		Greska! Korisnik Pera je vec dodat u chat 4.
		id = 4
		Pera (0)
		Zika (0)

	Poeni:
		2
*/
void test_4() {
	fstream file("test_4.txt", ios::out);

	User u1("Pera");
	User u2("Zika");
	User u3("Mika");

	Chat chat;

	try {
		chat.addUser(&u1);
		chat.addUser(&u2);
		chat.addUser(&u1);
		chat.addUser(&u3);
	}
	catch (exception& e) {
		file << e.what() << endl;
	}

	file << chat;
	file.close();
}

/*
	Izlaz (fajl Pera_5.txt):
		[Zika] Sta radis?

	Poeni:
		2
*/
void test_5() {
	User u1("Pera");
	User u2("Zika");

	Chat chat;

	chat.addUser(&u1);
	chat.addUser(&u2);

	u1.receiveMessage(chat.getId(), Message("Zika", "Sta radis?"));
	u1.readMessages(chat.getId());
}

/*
	Izlaz (fajl Pera_6.txt):
		[Zika] Cao!
		[Zika] Sta radis?

	Poeni:
		3
*/
void test_6() {
	User u1("Pera");
	User u2("Zika");

	Chat chat;

	chat.addUser(&u1);
	chat.addUser(&u2);

	u1.receiveMessage(chat.getId(), Message("Zika", "Cao!"));
	u1.receiveMessage(chat.getId(), Message("Zika", "Sta radis?"));
	u1.readMessages(chat.getId());
}

/*
	Izlaz (fajl Pera_7.txt):
		[Zika] Alo!
		[Zika] Kakav je ovo seen?

	Poeni:
		3
*/
void test_7() {
	User u1("Pera");
	User u2("Zika");

	Chat chat;

	chat.addUser(&u1);
	chat.addUser(&u2);

	u1.receiveMessage(chat.getId(), Message("Zika", "Cao!"));
	u1.receiveMessage(chat.getId(), Message("Zika", "Sta radis?"));
	u1.readMessages(chat.getId());
	u1.receiveMessage(chat.getId(), Message("Zika", "Alo!"));
	u1.receiveMessage(chat.getId(), Message("Zika", "Kakav je ovo seen?"));
	u1.readMessages(chat.getId());
}

/*
	Ulaz:
		Ziko?
		Miko?
		Reci

	Izlaz (fajl Pera_8.txt):
		[Zika] Reci

	Izlaz (fajl Zika_8.txt):
		[Pera] Ziko?
		[Pera] Miko?

	Izlaz (fajl Mika_8.txt):
		[Pera] Ziko?
		[Pera] Miko?
		[Zika] Reci

	Poeni:
		3
*/
void test_8() {
	User u1("Pera");
	User u2("Zika");
	User u3("Mika");

	Chat chat;

	chat.addUser(&u1);
	chat.addUser(&u2);
	chat.addUser(&u3);

	u1.sendMessage(chat.getId());
	u1.sendMessage(chat.getId());
	u2.sendMessage(chat.getId());

	u1.readMessages(chat.getId());
	u2.readMessages(chat.getId());
	u3.readMessages(chat.getId());
}

/*
	Ulaz:
		password
		password
		password
		password
		cao!
		cao i tebi!
		cao!
		cao i tebi!

	Izlaz:
		id = 9
		Pera (1)
		Zika (1)
		dbp!
		dbp j ufcj!

		id = 10
		Pera (1)
		Zika (1)
		bzn!
		bzn h sdah!

	Poeni:
		4
*/
void test_9() {
	fstream file("test_9.txt", ios::out);

	User u1("Pera");
	User u2("Zika");

	SecretChat chat1("password");
	SecretChat chat2("password");

	try {
		chat1.addUser(&u1);
		chat1.addUser(&u2);
		chat2.addUser(&u1);
		chat2.addUser(&u2);
	}
	catch (exception& e) {
		file << e.what() << endl;
	}

	chat1.setCipher(new CaesarCipher(1));
	chat2.setCipher(new CaesarCipher(25));

	u1.sendMessage(chat1.getId());
	u2.sendMessage(chat1.getId());
	u1.sendMessage(chat2.getId());
	u2.sendMessage(chat2.getId());

	file << chat1 << endl;
	file << chat2 << endl;

	file.close();
}

/*
	Ulaz:
		password
		password
		cao!
		cao i tebi!

	Izlaz:
		id = 11
		Pera (1)
		Zika (1)
		efx!
		efx s upgs!

	Poeni:
		4
*/
void test_10() {
	fstream file("test_10.txt", ios::out);

	User u1("Pera");
	User u2("Zika");

	SecretChat chat("password");

	try {
		chat.addUser(&u1);
		chat.addUser(&u2);
	}
	catch (exception& e) {
		file << e.what() << endl;
	}

	chat.setCipher(new MonoalphabeticCipher("map.txt"));

	u1.sendMessage(chat.getId());
	u2.sendMessage(chat.getId());

	file << chat << endl;

	file.close();
}

/*
	Izlaz (fajl test_11.txt):
		Pera [2]

		Ana [1]

		Mika [1]

		id = 12
		Pera (1)
		Ana (1)
		[Pera] Cao, sta radis?
		[Ana] Nista, ti?

		id = 13
		Pera (1)
		Mika (2)
		[Pera] AAaaaaa javilaa see
		[Mika] Zezaaas???
		[Mika] Sta je rekla?!

	Izlaz (fajl Pera_12.txt):
		[Ana] Nista, ti?

	Izlaz (fajl Pera_13.txt):
		[Mika] Zezaaas???
		[Mika] Sta je rekla?!

	Poeni:
		5
*/
void test_11() {
	fstream file("test_11.txt", ios::out);

	User u1("Pera");
	User u2("Ana");
	User u3("Mika");

	Chat chat1;
	Chat chat2;

	try {
		chat1.addUser(&u1);
		chat1.addUser(&u2);
		chat2.addUser(&u1);
		chat2.addUser(&u3);
	}
	catch (exception& e) {
		file << e.what() << endl;
	}

	u1.sendMessage(chat1.getId());
	u2.sendMessage(chat1.getId());

	u1.sendMessage(chat2.getId());
	u3.sendMessage(chat2.getId());

	u1.readMessages(chat1.getId());

	u3.sendMessage(chat2.getId());

	u1.readMessages(chat2.getId());

	file << u1 << endl << endl;
	file << u2 << endl << endl;
	file << u3 << endl << endl;
	file << chat1 << endl;
	file << chat2 << endl;

	file.close();
}

int main() {

	test_0();
	test_1();
	test_2();
	test_3();
	test_4();
	test_5();
	test_6();
	test_7();
	test_8();
	test_9();
	test_10();
	test_11();

	return 0;
}